#! /usr/bin/env python


import os.path
import string
from gtk import *

class PyAbDb:
	def __init__(self,ConfigFile="~/.pyabdb"):
		self.configfile=os.path.expanduser(ConfigFile)
		try:
			f=open(self.configfile,"r")
			self.Params=eval(f.read())
			f.close()
		except:
			print "Can't open/understand ",self.configfile,", using defaults"
			self.Params={
				"fields": ["First Name","Name","Title",
				"Organization","Email Adress"],
				"phone":["Home","Work","Fax","Mobile","Other"],
				"database":[]}
			self.changed=0
	def new(self,fn,n,e):
		x=[]
		for i in self.get_fields():
			if i=="First Name":
				x=x+[fn]
			else:
			   if i=="Name":
				x=x+[n]
			   else:
			      if i=="Email Adress":
				x=x+[e]
			      else:
			        x=x+[""]
		self.Params["database"]=self.Params["database"]+[x]
		self.changed=1
		return len(self.Params["database"])-1
	def match(self,a,b,ignore_case=0):
		a1=a
		b1=b
		if ignore_case:
			a1=string.lower(a)
			b1=string.lower(b)
		if b1[-1:]=="+":
			return (0==string.find(a1,b1[:-1]))
		return (a1==b1)
	def find_one(self,fields=[],vals=[],skip=0,ignore_case=0):
		if len(fields)!=len(vals): return -1
		t=self.get_fields()+["FullName1","FullName2"]
		for k in range(0,len(self.Params["database"])):
			f1=self.get_field("First Name",k)
			f2=self.get_field("Name",k)
			i=self.Params["database"][k]+[f1+" "+f2,f2+" "+f1]
			match=1
			for b in range(0,len(fields)):
			   if match==1:
				try:
					c=t.index(fields[b])
				except:
					print fields[b]+": no such field"
					return -2
				if not self.match(i[c],vals[b],ignore_case): match=0
			if match==1:
				if skip==0:
					return k
				else:
					skip=skip-1
		return -1
	def find_all(self,fields=[],vals=[],ignore_case=0):
		i=0;
		a=1;
		f=[]
		while a :
			a=self.find_one(fields,vals,i,ignore_case)
			if a>=0:
				f=f+[a]
				a=1
			i=i+1
			if a<0:
				a=0
		return f	
		
	def get_fields(self):
		return self.Params["fields"]+self.Params["phone"]

	def get_field(self,name,i):
		t=self.get_fields()
		try:
			c=t.index(name)
		except:
			print name+": no such field"
			return 0
		return self.Params["database"][i][c]
	def get_email(self,k):
		a=self.get_field("First Name",k)
		a=a+" "+self.get_field("Name",k)
		a=a+" <"+self.get_field("Email Adress",k)+">"
		return a
	def guess(self,s,ignore_case=0):
		a=self.find_all(["FullName1"],[s+"+"],ignore_case)
		a=a+self.find_all(["FullName2"],[s+"+"],ignore_case)
		a=a+self.find_all(["Email Adress"],[s+"+"],ignore_case)
		a.sort()
		i=0
		while i<len(a)-1:
			if a[i]==a[i+1]:
				a=a[:i]+a[i+1:]
			else:
				i=i+1
		return a
	def write(self):
		if self.changed:
			#print "writing to file: '%s'"%self.configfile
			f=open(self.configfile,"w")
                	f.write("%s"%self.Params)
                	f.close()
	def delete(self,i):
		self.Params["database"]=self.Params["database"][:i-1]+self.Params["database"][i:]
	def update(self,i,l):
		self.Params["database"][i]=l
		self.changed=1



class PyAb:
	def __init__(self):
		self.w=0;
	
	def cancel_button(self,e):
		if self.db.changed:
			self.db.delete(self.index)
		self.db.changed=0
		self.w.hide()
	def ok_button(self,e):
		if self.changed:
			a=[]
			for i in self.entries:
				a=a+[i.get_text()]
			self.db.update(self.index,a)
		self.db.write()
		self.w.hide()

	def edited(self,e):
		self.changed=1
	def on_destroy(self):
		self.w.hide()
	def draw(self,index,db,ro=0):
		self.db=db
		self.index=index
		self.info=db.Params["database"][index]
		self.changed=0
		if self.w==0:
			self.w=GtkWindow()
			self.w.show()
			self.w.connect('destroy',self.on_destroy)
			self.t=GtkTable(100,100,FALSE)
			self.t.show()
			self.w.add(self.t)
			self.fields=db.get_fields()
			self.entries=[]
			j=0
			for i in range(0,len(self.fields)):
				if self.fields[i]=="Home":
					l=GtkLabel("Phone:")
					l.show()
					self.t.attach(l,10,11,10+j,11+j)
					j=j+1
				l=GtkLabel(self.fields[i]+":")
				e=GtkEntry()
				e.set_text(self.info[i])
				e.set_editable(not ro)
				e.connect('changed',self.edited)
				self.entries=self.entries+[e]
				l.show()
				e.show()
				self.t.attach(l,10,11,10+j,11+j)
				self.t.attach(e,11,12,10+j,11+j)
				j=j+1
			bx=GtkHBox()
			bx.show()
			self.t.attach(bx,10,12,99,100)
			b=GtkButton("Cancel")
			b.connect('clicked',self.cancel_button)
			b.show()
			bx.pack_start(b) #,FALSE,FALSE,0)
			b=GtkButton("OK")
			b.connect('clicked',self.ok_button)
			b.show()
			bx.pack_start(b) #,FALSE,FALSE,0)
		else:
			for i in range(0,len(self.fields)):
				e=self.entries[i]
				e.set_text(self.info[i])
				e.set_editable(not ro)
			self.w.show()



if __name__=="__main__":



	db=PyAbDb()
	for i in db.guess("john",1):
		ab=PyAb()
		ab.draw(i,db)
	print db.get_email(i)
	mainloop()

